#ifndef _PlatformOcclusionQuery_H__
#define _PlatformOcclusionQuery_H__

#include <OgreHardwareOcclusionQuery.h>
#include <OgreRenderSystem.h>

#include "OcclusionQuery.h"

namespace Ogre {

/** This class is an implementation for occlusion queries using Ogre.
	@remark the class encapsulates Ogre occlusion query calls.
*/
class PlatformOcclusionQuery: public GtpVisibility::OcclusionQuery
{
public:
	
	PlatformOcclusionQuery(RenderSystem *rsys);

	virtual ~PlatformOcclusionQuery();

	virtual bool GetQueryResult(unsigned int &queryResult,
	const bool waitForResult) const;
	virtual void BeginQuery();
	virtual void EndQuery();

protected:
	HardwareOcclusionQuery *mHardwareOcclusionQuery;
};

} // namespace Ogre
#endif // PlatformOcclusionQuery_H